function custom_load(customlevel,editorMode) --initializes all variables
	updates = 0
	gamestate = "custom"
	gamestarted = false
	editormode=editorMode
	
	lockmouse()

	origlevel=deepcopy(customlevel)
	level=customlevel
	custom_createworld(level)
	
	if soundenabled then
		love.audio.stop(beginning)
		love.audio.play(beginning)
	end
	
	waorka = 1
	prevghostpos = false
	ghostmove = {}
	ghostvolume = 0
	gametime = 0
	eatored = 0
	score = 0
	lives = level.flags.lifes
	superpellettimer = 0
	superpelletblink = false
	powerup = false
	starttimer = love.timer.getTime()
	deathtimer = deathtime+deathdelay
	pacmouthopenness = pacmouthlimit
	
	ghosttimer = {}
	for i = 1, #level.ghosts do
		ghosttimer[i] = 0
	end
	ghostdeadstartx = {}
	ghostdeadstarty = {}
	ghostdeadendx = {}
	ghostdeadendy = {}
	ghostdeadr = {}
	
	ghosttime = 1
	blinktime = 2
	blinkrate = 0.3
	
	rotation = 0
	if level.flags["particles on powerup"] then
		local color = level.flags["particles color"]
		pacmanparticles=love.graphics.newParticleSystem(superpellet,1000)
		pacmanparticles:setColors(
			255,255,255,255,
			-- (color[1]+255)/2,(color[2]+255)/2,(color[3]+255)/2,192,
			(color[1]/255)^.5*255,(color[2]/255)^.5*255,(color[3]/255)^.5*255,255,
			(color[1]/255)^.5*255,(color[2]/255)^.5*255,(color[3]/255)^.5*255,192,
			color[1],color[2],color[3],127,
			(color[1]/255)^2*255,(color[2]/255)^2*255,(color[3]/255)^2*255,127,
			(color[1]/255)^2*255,(color[2]/255)^2*255,(color[3]/255)^2*255,0)
		pacmanparticles:setEmissionRate(400)
		pacmanparticles:setParticleLife(1,2.5)
		pacmanparticles:setSpread(10)
		pacmanparticles:setSpeed(0,15)
		pacmanparticles:setSizes(4,2,3,1)
		pacmanparticles:setOffset(2.5,2.5)
		pacmanparticles:setRotation(-5,5)
		pacmanparticles:setRadialAcceleration(-10,10)
		pacmanparticles:setSpin(-5,5)
		pacmanparticles:stop()
	end
	targetrotation = 0
	custom_updategravity(1)
	
	totalpelletnumber=0
	for i,v in pairs(level.pellets) do
		totalpelletnumber=totalpelletnumber+1
	end	
	if mousecontrol2 then
		love.mouse.setPosition(windowwidth/2, windowheight/2)
	end
	--skipupdate = true
end

function custom_afterdeath()
	if lives > 1 then
		lives = lives - 1
	
		superpellettimer = 0
		superpelletblink = false
		powerup = false
		if level.flags["particles on powerup"] then
			pacmanparticles:reset()
			pacmanparticles:stop()
		end
		pacmanfix:setRestitution(level.flags['pacman bounce'])
		starttimer = love.timer.getTime()
		deathtimer = deathtime+deathdelay
		pacmouthopenness = pacmouthlimit
		
		rotation = 0
		targetrotation = 0
		custom_updategravity(1)
		gamestarted = false
		custom_createworld(origlevel)
		waorka = 1
		prevghostpos=false
		
		ghosttimer = {}
		for i = 1, nbghosts do
			ghosttimer[i] = 0
		end
		
		if controlmethod == "mouse direction" or controlmethod == "mouse" then
			love.mouse.setPosition(screenwidth/2, screenheight/4)
		end
	else
		custom_gamefinished()
	end
end

function custom_update(dt)
	if gamestarted and eatored > 0 then
		gametime = gametime + dt
	end
	currenttime = love.timer.getTime()
	
	custom_updategravity(dt)
	if gamestarted == false then
		if currenttime - starttimer > 0 then
			custom_start()
		end
	elseif deathtimer < deathtime+deathdelay then
		deathtimer = deathtimer + dt
		
		if deathtimer > deathtime then
			pacmouthopenness = 1
		else
			pacmouthopenness = pacmouthlimit + (1-pacmouthlimit) * (deathtimer/deathtime)
		end
		
		if deathtimer > deathtime + deathdelay then
			deathtimer = deathtime + deathdelay
			custom_afterdeath()
		end
	else
		if level.flags["particles on powerup"] then
			pacmanparticles:setPosition(pacmanbody:getPosition())
			pacmanparticles:update(dt)
		end

		--wakka animation
		if currenttime - wakkatimer < mouthduration then
			if currenttime - wakkatimer < mouthduration/2 then
				pacmouthopenness = pacmouthlimit-pacmouthlimit*((currenttime-wakkatimer)/(mouthduration/2))
			else
				pacmouthopenness = pacmouthlimit*((currenttime-wakkatimer-mouthduration/2)/(mouthduration/2))
			end
		else
			pacmouthopenness = pacmouthlimit
		end
		
		--powerup runout
		if powerup then
			if currenttime - poweruptimer > level.flags["powerup duration"] then
				powerup = false
				if level.flags["particles on powerup"] then
					pacmanparticles:stop()
				end
				pacmanfix:setRestitution(level.flags['pacman bounce'])
				if superpower == "walls" then
					pacmanshape:setMask()
				elseif superpower == "clone" then
					clonebody:destroy()
					cloneshape:destroy()
					pacmanshape:setMask()
				end
			end
		end
		
		--superpellet blink
		if currenttime - superpellettimer > superpelletblinkrate then
			superpelletblink = not superpelletblink
			superpellettimer = currenttime
		end
		
		--joystick
		if controlmethod == "joystick" then
			x = love.joystick.getAxis( 1, 0 )
			y = -love.joystick.getAxis( 1, 1 )
			if math.abs(x) + math.abs(y) > joystickdeadzone then
				targetrotation = math.deg(math.atan2(x, y) )
			end
		elseif controlmethod == "wheel steering" then
			x = love.joystick.getAxis( 1, 0)
			targetrotation = targetrotation+x*dt*400
			if targetrotation < 0 then
				targetrotation = targetrotation + 360
			elseif targetrotation > 360 then
				targetrotation = targetrotation - 360
			end
		elseif controlmethod == "wheel direct" then
			x = love.joystick.getAxis( 1, 0)
			targetrotation = x*180
			if targetrotation < 0 then
				targetrotation = targetrotation + 360
			end
		elseif controlmethod == "keyboard" then
			local multiplier = 100
			if love.keyboard.isDown( "rshift" ) or love.keyboard.isDown( "lshift" ) then
				multiplier = 300
			end
			if love.keyboard.isDown( "left" ) then
				targetrotation = targetrotation - multiplier*dt
				custom_updategravity(dt)
			end
			if love.keyboard.isDown( "right" ) then
				targetrotation = targetrotation + multiplier*dt
				custom_updategravity(dt)
			end
		elseif controlmethod == "mouse direction" then
			x, y = love.mouse.getPosition( )
			x = x - screenwidth/2
			y = (screenheight - y) - screenheight/2
			targetrotation = math.deg(math.atan2(x, y))
			custom_updategravity(dt)
		elseif controlmethod == "mouse" then
			x, y = love.mouse.getPosition()
			
			if oldx then
				diff = x-oldx
				targetrotation = targetrotation+diff*dt*mouse2speed
			end
			
			oldx, oldy = x, y
			
			updates = updates + dt
			if updates > mouse2rate then
				updates = 0
				oldx = windowwidth/2
				love.mouse.setPosition(windowwidth/2, windowheight/2)
			end
		end
		
		--pacman stuff
		x, y = custom_pacmangetposition(pacmanbody:getX(), pacmanbody:getY())
		custom_checkpellet(x, y)
		
		--check for death
		for i,v in ipairs(level.ghosts) do
			if ghosttimer[i] == 0 then
				local dist = math.sqrt((pacmanbody:getX()-ghostbody[i]:getX())^2 + (pacmanbody:getY()-ghostbody[i]:getY())^2)
				if dist < 12 then
					if powerup then
						--kill ghost
						ghostbody[i]:setLinearVelocity(0, 0)
						ghostbody[i]:setAngularVelocity(0)
						ghosttimer[i] = ghosttime
						ghostdeadstartx[i] = ghostbody[i]:getX()
						ghostdeadstarty[i] = ghostbody[i]:getY()
						ghostdeadendx[i] = v[1]
						ghostdeadendy[i] = v[2]
						ghostbody[i]:setX(0)
						ghostbody[i]:setY(0)
						ghostdeadr[i] = ghostbody[i]:getAngle()
						eatghost:stop()
						eatghost:play()
					else
						gamestarted = false
						superpelletblink = false
						deathtimer = 0
						custom_stopgamesounds()
						death:play()
					end
				end
			end
		end
		
		for i,v in ipairs(ghosttimer) do
			if ghosttimer[i] > 0 then
				ghosttimer[i] = ghosttimer[i] - dt
				if ghosttimer[i] <= 0 then
					ghostbody[i]:setX(level.ghosts[i][1])
					ghostbody[i]:setY(level.ghosts[i][2])
					ghostbody[i]:setLinearVelocity(0, 0)
					ghostbody[i]:setAngularVelocity(0)
					ghosttimer[i] = 0
				else
					ghostbody[i]:setX(0)
					ghostbody[i]:setY(0)
					ghostbody[i]:setLinearVelocity(0, 0)
					ghostbody[i]:setAngularVelocity(0)
				end
			end
		end
		
		
		--Teleport
		-- if y == 14 and x < 2 then
		-- 	pacmanbody:setX(screenwidth/2+11.5*8*2)
		-- elseif y == 14 and x > 25 then
		-- 	pacmanbody:setX(screenwidth/2-11.5*8*2)
		-- end
		
		-- for i = 1, #ghosttimer do
		-- 	x, y = custom_pacmangetposition(ghostbody[i]:getX(), ghostbody[i]:getY())
		-- 	--Teleport
		-- 	if y == 14 and x < 2 then
		-- 		ghostbody[i]:setX(screenwidth/2+11.5*8*2)
		-- 	elseif y == 14 and x > 25 then
		-- 		ghostbody[i]:setX(screenwidth/2-11.5*8*2)
		-- 	end
		-- end
		
		if gamestarted and prevghostpos then
			calcghostvolume = 0
			for i = 1, #ghosttimer do
				ghostmovediag = (ghostbody[i]:getX() - prevghostpos[i][1])+(ghostbody[i]:getY()- prevghostpos[i][2])
				if ghostmovediag < 0 then ghostmovediag = -ghostmovediag end
				ghostmove[i] = math.sqrt(ghostmovediag)
				calcghostvolume=calcghostvolume+ghostmove[i]
				prevghostpos[i] = {ghostbody[i]:getX(), ghostbody[i]:getY()}
			end

			calcghostvolume=calcghostvolume/#ghosttimer-0.15
			if calcghostvolume < 0 then calcghostvolume = 0 end
			if calcghostvolume > ghostvolume then
				ghostvolume = ghostvolume + 0.02
			elseif calcghostvolume == 0 then
				ghostvolume = ghostvolume - 0.06
			elseif calcghostvolume < ghostvolume then
				ghostvolume = ghostvolume - 0.02
			end
			if ghostvolume > 0.6 then ghostvolume = 0.6 end
			
		else
			prevghostpos = {}
			ghostvolume = 0
		end
		
		if powerup then
			ghostrunaway:setVolume(ghostvolume+0.3)
			ghostsiren:setVolume(0)
		else
			ghostrunaway:setVolume(0)
			ghostsiren:setVolume(ghostvolume)
		end
		
		
		
		
		--wake up ghosts so they don't get stuck. Fucking box2d, how does it work
		pacmanbody:setAwake(true)
		for i = 1, #ghosttimer do	
			ghostbody[i]:setAwake(true)
			prevghostpos[i] = {ghostbody[i]:getX(), ghostbody[i]:getY()}
		end
		
		world:update(dt)
	end
end

function custom_stopgamesounds()
	ghostrunaway:setVolume(0)
	ghostsiren:setVolume(0)
	ghostvolume = 0
	beginning:stop()
	eatghost:stop()
	wakka1:stop()
	wakka2:stop()
	death:stop()
	love.audio.stop()
end

function custom_draw()
	love.graphics.setColor(level.flags["background color"])
	--I wont fuck up the background color
	love.graphics.rectangle("fill",0,gamestate=="menu" and -windowheight*(gamestatemovetimer-1)/3 or 0,screenwidth,screenheight)
	love.graphics.setColor(255,255,255)
	--guideline for joystick
	if joystickcontrol and deathtimer == deathtime+deathdelay then
		x = love.joystick.getAxis( 1, 0 )
		y = love.joystick.getAxis( 1, 1 )
		love.graphics.line(screenwidth/2, screenheight/2, screenwidth/2+x*(screenheight/2), screenheight/2+y*(screenheight/2))
	end
	
	--Rotate
	love.graphics.push()
	love.graphics.translate(screenwidth/2, screenheight/2)
	love.graphics.rotate(math.rad(rotation))
	love.graphics.scale(zoom)
	
	--Change focus on pacman if pacfocus == true, also scale.
	if pacfocus or level.flags["force 1st person"] then
		love.graphics.translate((screenwidth/2-pacmanbody:getX()*scale)-screenwidth/2, (screenheight/2-pacmanbody:getY()*scale)-screenheight/2)
	-- else
		-- love.graphics.translate(-screenwidth/2, -screenheight/2)
	end
	
	--Background, Pacman, clone and background overlay.
	love.graphics.setColor(level.flags["walls color"])
	for i,v in ipairs(level.walls) do
		if v[5] then
			love.graphics.push()
			love.graphics.translate(worldbodies["i"..i]:getX()*scale,worldbodies["i"..i]:getY()*scale)
			love.graphics.rotate(worldbodies["i"..i]:getAngle())
			fillstyledrect(v[3]*scale/-2,v[4]*scale/-2,v[3]*scale,v[4]*scale)
			love.graphics.pop()
		else
			fillstyledrect(v[1]*scale,v[2]*scale,v[3]*scale,v[4]*scale)
		end
	end
	love.graphics.setColor(level.flags["walls fill color"])
	for i,v in ipairs(level.walls) do
		if v[5] then
			love.graphics.push()
			love.graphics.translate(worldbodies["i"..i]:getX()*scale,worldbodies["i"..i]:getY()*scale)
			love.graphics.rotate(worldbodies["i"..i]:getAngle())
			love.graphics.rectangle("fill",v[3]*scale/-2+2*scale,v[4]*scale/-2+scale,v[3]*scale-4*scale,v[4]*scale-2*scale)
			love.graphics.rectangle("fill",v[3]*scale/-2+scale,v[4]*scale/-2+2*scale,v[3]*scale-2*scale,v[4]*scale-4*scale)
			love.graphics.pop()
		else
			love.graphics.rectangle("fill",v[1]*scale+2*scale,v[2]*scale+scale,v[3]*scale-4*scale,v[4]*scale-2*scale)
			love.graphics.rectangle("fill",v[1]*scale+scale,v[2]*scale+2*scale,v[3]*scale-2*scale,v[4]*scale-4*scale)
		end
	end

	
	--pellets!
	
	for k,v in pairs(level.pellets) do
		if v[3] == 1 then
			love.graphics.setColor(level.flags["pellets color"])
			love.graphics.rectangle( "fill", math.floor(((v[2])*8-0.4+2)*scale), math.floor(((v[1])*7-0.4+3)*scale), 2*scale, 2*scale)
		elseif v[3] == 2 and superpelletblink == false then
			love.graphics.setColor(level.flags["super pellets color"])
			love.graphics.draw(superpellet, math.floor(((v[2])*8-2.5+2)*scale), math.floor(((v[1])*7-2.5+3)*scale), 0, scale)
		end
	end
	-- love.graphics.setColor(255, 255, 255, 255)
	--pac:
	local x = (pacmanbody:getX()*scale-screenwidth/2)+screenwidth/2
	local y = (pacmanbody:getY()*scale-screenheight/2)+screenheight/2
	
	love.graphics.setColor(255, 255, 50)
	love.graphics.arc("fill",x,y,6.5*scale,math.pi*2*(pacmouthopenness/2)+pacmanbody:getAngle(),math.pi*2 - math.pi*2*(pacmouthopenness/2)+pacmanbody:getAngle())
	love.graphics.setColor(255, 255, 255)
	
	
	--ghosties:
	if deathtimer == deathtime+deathdelay then
		for i = 1, #ghosttimer do
			if ghosttimer[i] == 0 then
				if powerup then
					--powerup blink
					local timeleft = level.flags["powerup duration"] - (love.timer.getTime() - poweruptimer)
					
					if timeleft < blinktime and math.mod((timeleft), blinkrate*2)<blinkrate then
						love.graphics.draw( ghostscared2, (ghostbody[i]:getX()*scale-screenwidth/2)+screenwidth/2, (ghostbody[i]:getY()*scale-screenheight/2)+screenheight/2, ghostbody[i]:getAngle(), scale/41, scale/41, 256, 256)
					else
						love.graphics.draw( ghostscared1, (ghostbody[i]:getX()*scale-screenwidth/2)+screenwidth/2, (ghostbody[i]:getY()*scale-screenheight/2)+screenheight/2, ghostbody[i]:getAngle(), scale/41, scale/41, 256, 256)
					end
				else
					love.graphics.push()
					love.graphics.translate((ghostbody[i]:getX()*scale-screenwidth/2)+screenwidth/2, (ghostbody[i]:getY()*scale-screenheight/2)+screenheight/2)
					love.graphics.rotate(ghostbody[i]:getAngle())
					love.graphics.setColor(ghostcolors[(i-1)%#ghostcolors+1])
					love.graphics.draw(ghost, 0, 0, 0, scale/41, scale/41, 256, 256)
					love.graphics.setColor(255,255,255)
					love.graphics.draw(ghosteyeswhite, 0, 0, 0, scale/41, scale/41, 256, 256)
					local down = -(ghostbody[i]:getAngle()+math.rad(rotation))+math.pi/2
					love.graphics.draw(spinnyeyes, math.cos(down)*1*scale, math.sin(down)*1.5*scale-0.5*scale, 0, scale/41, scale/41, 145, 35)
					love.graphics.pop()
				end
			else	
				local x = ghostdeadstartx[i] + (ghostdeadendx[i]-ghostdeadstartx[i])*(1-ghosttimer[i]/ghosttime)
				local y = ghostdeadstarty[i] + (ghostdeadendy[i]-ghostdeadstarty[i])*(1-ghosttimer[i]/ghosttime)
				love.graphics.draw(ghosteyes, (x*scale-screenwidth/2)+screenwidth/2, (y*scale-screenheight/2)+screenheight/2, ghostdeadr[i], scale/41, scale/41, 256, 256)
			end
		end
	end
	
	
	
	love.graphics.setColor(255, 255, 255)
	if level.flags["particles on powerup"] then
		love.graphics.draw(pacmanparticles,0,0,0,scale)
	end
	
	
	--Rotate
	love.graphics.pop()
	drawgui()
	if editormode then
		love.graphics.setColor(255,64,32,192)
		love.graphics.print("testing level, fps:"..love.timer.getFPS(),40*scale,2*scale,0,scale)
		love.graphics.setColor(255, 255, 255)
	end
end

function custom_createworld(customlevel) --creates world and all physics objects
	local scale = 2
	world = love.physics.newWorld(0, 800, false)
	
	fieldbody = love.physics.newBody(world,0,0)
	fieldbody:setBullet(true)
	worldbodies = {}--for dynamic bodies
	worldshapes = {}
	worldfix= {}

	--Not to be masked: 1, 2, 3, 4, 5, 6, 20, 21, 23, 26
	--No, I wrote a program to grab these for me easily.
	
	for i,v in ipairs(customlevel.walls) do
		if v[5] then
			table.insert(worldshapes,love.physics.newRectangleShape(v[3],v[4]))
			worldbodies["i"..i]=love.physics.newBody(world,v[1]+v[3]/2,v[2]+v[4]/2,"dynamic")
			worldfix[i]=love.physics.newFixture(worldbodies["i"..i],worldshapes[i])
		else
			table.insert(worldshapes,love.physics.newRectangleShape(
				(v[1]+v[3]/2),
				(v[2]+v[4]/2),
				v[3],v[4]))
			worldfix[i]=love.physics.newFixture(fieldbody,worldshapes[i])
		end
	end
	-- for i,v in ipairs({7,8,9,10,11,12,13,14,15,16,17,18,19,22,24,25,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42}) do
	-- 	worldfix[v]:setCategory(2)
	-- end
	--59 590
	--paccy
	pacmanbody = love.physics.newBody(world,customlevel.player[1],customlevel.player[2],"dynamic")
	pacmanbody:setBullet(true)
	pacmanbody:setInertia( 0.001 )
	pacmanbody:setMass(0.1)
	pacmanshape = love.physics.newCircleShape(0, 0, 6.5)
	pacmanfix=love.physics.newFixture(pacmanbody,pacmanshape)
	pacmanfix:setMask(3)
	pacmanfix:setRestitution(level.flags['pacman bounce'])
	-- pacmanfix:setFriction( 1000)
	
	--ghosties!
	ghostbody = {}
	ghostshape = {}
	ghostfix = {}
	for i,v in ipairs(customlevel.ghosts) do
		ghostbody[i] = love.physics.newBody(world, v[1], v[2],"dynamic")
		ghostbody[i]:setMass(0.1)
		ghostbody[i]:setBullet(true)
		ghostbody[i]:setInertia(0.001)
		ghostshape[i] = love.physics.newCircleShape(0, 0, 6.5)
		ghostfix[i]=love.physics.newFixture(ghostbody[i],ghostshape[i])
		ghostfix[i]:setCategory(3)
		ghostfix[i]:setRestitution(level.flags['ghost bounce'])
		-- ghostfix[i]:setFriction(1000)
	end
end

function custom_start() --when game becomes controllable
	gamestarted = true
	ghostsiren:play()
	ghostrunaway:play()
end

function custom_updategravity(dt) --"rotates" the world. (It actually only changes the gravity "direction" because actually rotating the world caused centrifugalforces to be a bitch)
	--smooth targetrotation into rotation
	
	targetrotation = math.mod(targetrotation+360, 360)
	
	if targetrotation > rotation + 180 then
		rotation = rotation + 360
	elseif targetrotation < rotation - 180 then
		rotation = rotation - 360
	end
	
	if targetrotation > rotation then
		rotation = rotation + (targetrotation-rotation)*dt*20
	else
		rotation = rotation + (targetrotation-rotation)*dt*20
	end
	
	gravityX = math.sin(math.rad(rotation))
	gravityY = math.cos(math.rad(rotation))	
	world:setGravity( gravityX*level.flags.gravity, gravityY*level.flags.gravity )
end

function custom_pacmangetposition(worldx, worldy) --returns position of world coordinates converted to the pelletgrid
	-- local scale = 2
	worldx = worldx - 3*1.0
	worldy = worldy - 3*1.0
	x = math.floor((worldx-4*1.0)/(8*1.0)+1)
	y = math.floor((worldy-3.5*1.0)/(7*1.0)+1)
	return x, y
end

function custom_checkpellet(x, y) --checks a coordinate if it contains a pellet and does stuff
	if level.pellets[y.." "..x] then
		if level.pellets[y.." "..x][3] == 1 then
			level.pellets[y.." "..x] = nil
			if currenttime - wakkatimer > 0.09 then --0.11
				if soundenabled then
					if waorka == 1 then
						love.audio.stop(wakka2)
						love.audio.play(wakka2)
						waorka = 0
					else
						love.audio.stop(wakka1)
						love.audio.play(wakka1)
						waorka = 1
					end
				end
				wakkatimer = currenttime
			end
			
			score = score + 10
			
			eatored = eatored + 1
			if eatored == totalpelletnumber then
				custom_gamefinished()
			end
			
		elseif level.pellets[y.." "..x][3] == 2 then
			level.pellets[y.." "..x] = nil
			currenttime = love.timer.getTime()
			if currenttime - wakkatimer > 0.11 then
				if soundenabled then
					if waorka then
						love.audio.stop(wakka2)
						love.audio.play(wakka2)
						waorka = 0
					else
						love.audio.stop(wakka1)
						love.audio.play(wakka1)
						waorka = 1
					end
				end
				wakkatimer = currenttime
			end	
			
			--SUPER POWERS OMG
			poweruptimer = currenttime
			powerup = true
			if level.flags["particles on powerup"] then
				pacmanparticles:start()
			end
			pacmanfix:setRestitution(level.flags['super pacman bounce'])
			
			score = score + 50
			
			eatored = eatored + 1
			if eatored == totalpelletnumber then
				custom_gamefinished()
			end
		end
	end
end

function custom_keypressed(key)
	if key == "escape" then
		custom_stopgamesounds()
		if editormode then
			editor_load(origlevel)
		else 
			pause_load()
		end
	end
end

function custom_mousepressed(x, y, button)

end

function custom_gamefinished()	
	custom_stopgamesounds()
	love.mouse.setGrab(false)
	love.mouse.setVisible(true)
	if eatored == totalpelletnumber then
		gamewin:play()
	end	
	if editormode then
		editor_load(origlevel)
	else 
		-- menu_load(true)
		customhighscore_load()
	end
end