function editor_load(customlevel,Scroll)
	prevgamestate = gamestate
	gamestatemovetimer=1
	gamestate = "editor"
	releasemouse()
	tools={"walls","player spawn","ghosts","pellets","super pellets"}
	toolsdesc={
		['walls']='place a wall. right click to edit',
		['player spawn']="where the player will spawn",
		['ghosts']="l c to drag,r c to create/delete",
		['pellets']="nom!-right click to erase-",
		['super pellets']="for a super pacman!-r click to erase-"}
	currentdesc="use your mousewheel to change tool."
	shorcuts={"save","load","erase","flags","help","axis","zoom","unzoom"}
	helptext=love.filesystem.read('editorhelp.txt')
	helpshown=false
	helpwidth=250
	helpstuff={pacmanfont:getWrap(helptext,helpwidth)}
	symmetrymodes={" / ","x/ "," /y","x/y"}
	symmetry=1

	tool=1
	if customlevel then
		level=customlevel
	else
		level=editor_newlevel()
	end
	pelletmousepos={0,0}
	scroll=Scroll or {screenwidth/2,screenheight/2}
	draggingghost=false
	makingwall=false
end
function editor_newlevel()
	local thenewlevel = {}
	thenewlevel.walls={}
	table.insert(thenewlevel.walls,{-3-boardwidth/2,-3-boardheight/2,boardwidth+3*2,3,false})
	table.insert(thenewlevel.walls,{-3-boardwidth/2,boardheight/2,boardwidth+3*2,3,false})
	table.insert(thenewlevel.walls,{-3-boardwidth/2,-3-boardheight/2,3,boardheight+3*2,false})
	table.insert(thenewlevel.walls,{boardwidth/2,-3-boardheight/2,3,boardheight+3*2,false})
	thenewlevel.player={0,boardheight/6}
	thenewlevel.ghosts={}
	for i=1,nbghosts do
		table.insert(thenewlevel.ghosts,{(i-(nbghosts+1)/2)*15,-boardheight/6})
	end
	-- thenewlevel.ghosts={0,-boardheight/6}
	thenewlevel.pellets={}
	thenewlevel.flags={}
	for i,v in ipairs(flagslist) do
		thenewlevel.flags[v.name]=v.default
	end
	return thenewlevel
end
function editor_update(dt)
	gamestatemovetimer=math.max(gamestatemovetimer-dt*4,0)
	mousepos={
	math.floor((love.mouse.getX()-scroll[1]+3)/scale/zoom),
	math.floor((love.mouse.getY()-scroll[2]+3)/scale/zoom)}
	pelletmousepos[1]=math.floor(((love.mouse.getX()-boardwidth*(scale*zoom)/2-scroll[1])/(scale*zoom)+.4)/8+13.5-.5)+1
	pelletmousepos[2]=math.floor(((love.mouse.getY()-boardheight*(scale*zoom)/2-scroll[2])/(scale*zoom)+.4)/7+15-.5)+1
	if love.mouse.isDown('l') then
		if tools[tool]=="pellets" then
			level.pellets[tostring(pelletmousepos[2]).." "..tostring(pelletmousepos[1])]={pelletmousepos[2],pelletmousepos[1],1}
		elseif tools[tool]=="super pellets" then
			level.pellets[tostring(pelletmousepos[2]).." "..tostring(pelletmousepos[1])]={pelletmousepos[2],pelletmousepos[1],2}
		end
	elseif love.mouse.isDown('r') and (tools[tool]=="pellets" or tools[tool]=="super pellets") then
		level.pellets[tostring(pelletmousepos[2]).." "..tostring(pelletmousepos[1])]=nil
	end

	if love.keyboard.isDown("left") then
		scroll[1]=scroll[1]+math.floor(400*dt*scale*zoom)
	elseif love.keyboard.isDown("right") then
		scroll[1]=scroll[1]-math.floor(400*dt*scale*zoom)
	end
	if love.keyboard.isDown("up") then
		scroll[2]=scroll[2]+math.floor(400*dt*scale*zoom)
	elseif love.keyboard.isDown("down") then
		scroll[2]=scroll[2]-math.floor(400*dt*scale*zoom)
	end
	if draggingghost~=false then
		level.ghosts[draggingghost][1]=mousepos[1]
		level.ghosts[draggingghost][2]=mousepos[2]
	end
end

function editor_draw()
	if gamestatemovetimer~=0 and prevgamestate~="editor" then
		love.graphics.push()
		love.graphics.translate(0,windowheight*(1-gamestatemovetimer))
		love.graphics.setColor(255,255,255)
		_G[prevgamestate.."_draw"]()
		love.graphics.pop()
	end
	love.graphics.push()
	if gamestate=="editor" then
		love.graphics.translate(windowwidth*(gamestatemovetimer),windowheight*(-gamestatemovetimer))
	end
	love.graphics.setColor(level.flags["background color"])
	--I wont fuck up the background color
	love.graphics.rectangle("fill",0,0,screenwidth,screenheight)
	love.graphics.setColor(255,255,255)

	love.graphics.push()
	love.graphics.translate(scroll[1],scroll[2])
	love.graphics.scale(zoom)

	love.graphics.setColor(255,27,27)
	love.graphics.rectangle("fill",-scroll[1]/zoom,0,screenwidth/zoom,scale)
	love.graphics.setColor(27,27,255)
	love.graphics.rectangle("fill",0,-scroll[2]/zoom,scale,screenheight/zoom)

	drawcustomlevel(level,{-scroll[1]/scale/zoom,-scroll[2]/scale/zoom,screenwidth/scale/zoom,screenheight/scale/zoom})

	love.graphics.setColor(255,27,27,127)
	love.graphics.rectangle("fill",-scroll[1]/zoom,0,screenwidth/zoom,scale)
	love.graphics.setColor(27,27,255,127)
	love.graphics.rectangle("fill",0,-scroll[2]/zoom,scale,screenheight/zoom)

	love.graphics.setColor(255,255,255)
	if makingwall~=false then
		local x1,y1,x2,y2 = math.min(makingwall[1]*scale,mousepos[1]*scale),
		math.min(makingwall[2]*scale,mousepos[2]*scale),
		math.abs(makingwall[1]*scale-mousepos[1]*scale),
		math.abs(makingwall[2]*scale-mousepos[2]*scale)
		drawstyledrect(x1,y1,x2,y2)
		if symmetry%2==0 then--x
			drawstyledrect(-x1,y1,-x2,y2)
		end
		if symmetry>2 then--y
			drawstyledrect(x1,-y1,x2,-y2)
		end
		if symmetry==4 then--x/y
			drawstyledrect(-x1,-y1,-x2,-y2)
		end
	end
	love.graphics.pop()
	love.graphics.setColor(255,255,255)
	love.graphics.print("tool:"..tools[tool],2*scale,2*scale,0,scale)

	for i,v in ipairs(shorcuts) do
		love.graphics.setColor(255,255,255)
		love.graphics.print(v,2*scale,(10+10*i)*scale,0,scale)
		love.graphics.setColor(255,27,27)
		love.graphics.print(v:sub(1,1),2*scale,(10+10*i)*scale,0,scale)
	end

	love.graphics.setColor(255,255,255,127)
	love.graphics.print(currentdesc,screenwidth-(8*currentdesc:len()+2)*scale,screenheight-(2+8)*scale,0,scale)
	love.graphics.setColor(255,255,255)
	love.graphics.print(symmetrymodes[symmetry],2*scale,screenheight-(2+8)*scale,0,scale)
	love.graphics.draw(toolsimg,screenwidth-toolsimg:getWidth()*scale,0,0,scale)
	love.graphics.rectangle('line',screenwidth-toolsimg:getWidth()*scale+(tool-1)*16*scale+scale,-scale,16*scale,16*scale)
	if helpshown then
		love.graphics.push()
		love.graphics.translate(screenwidth/2-helpwidth*scale/2,screenheight/2-helpstuff[2]*pacmanfont:getHeight()*1.5*scale/2)

		love.graphics.setColor(127,27,27,192)
		love.graphics.rectangle("fill",-4*scale,-4*scale,helpwidth*scale+4*scale*2,helpstuff[2]*pacmanfont:getHeight()*1.5*scale+4*scale*2)

		love.graphics.setColor(64,14,14,192)
		drawstyledrect(-5*scale,-5*scale,helpwidth*scale+5*scale*2,helpstuff[2]*pacmanfont:getHeight()*1.5*scale+5*scale*2)

		love.graphics.setColor(255,255,255)
		love.graphics.scale(scale)
		love.graphics.printf(helptext,0,0,helpwidth,"left")
		love.graphics.pop()
	end
	love.graphics.pop()
end
function drawcustomlevel(level,viewbox)
	r,g,b,a=love.graphics.getColor()
	love.graphics.setColor(level.flags["walls fill color"])
	for i,v in ipairs(level.walls) do
		if not viewbox or aabb(viewbox,v) then
			love.graphics.rectangle("fill",v[1]*scale+scale,v[2]*scale+scale,v[3]*scale-2*scale,v[4]*scale-2*scale)
		end
	end
	love.graphics.setColor(255, 255, 255)
	-- love.graphics.rectangle("line",0,0,boardwidth*scale,boardheight*scale)
	love.graphics.setColor(level.flags["walls color"])
	for i,v in ipairs(level.walls) do
		if not viewbox or aabb(viewbox,v) then
			drawstyledrect(v[1]*scale,v[2]*scale,v[3]*scale,v[4]*scale)
		end
	end
	love.graphics.setColor(255, 255, 0)
	for k,v in pairs(level.pellets) do
		if not viewbox or aabb({math.floor(((v[2])*8-2.5+2)), math.floor(((v[1])*7-2.5+3)),5,5},viewbox) then
			if v[3] == 1 then
				love.graphics.setColor(level.flags["pellets color"])
				love.graphics.rectangle( "fill", math.floor(((v[2])*8-0.4+2)*scale), math.floor(((v[1])*7-0.4+3)*scale), 2*scale, 2*scale)
			elseif v[3] == 2 then
				love.graphics.setColor(level.flags["super pellets color"])
				love.graphics.draw(superpellet,math.floor(((v[2])*8-2.5+2)*scale), math.floor(((v[1])*7-2.5+3)*scale), 0, scale)
			end
		end
	end
	love.graphics.setColor(255, 255, 50)
	love.graphics.arc("fill",level.player[1]*scale,level.player[2]*scale,6.5*scale,math.pi*.25,math.pi*1.75)
	love.graphics.setColor(255,255,255)
	for i,v in ipairs(level.ghosts) do
		local x,y = level.ghosts[i][1]*scale,level.ghosts[i][2]*scale
		love.graphics.setColor(ghostcolors[(i-1)%#ghostcolors+1])
		love.graphics.draw(ghost,x,y,0,scale/41, scale/41, 256, 256)
		love.graphics.setColor(255,255,255)
		love.graphics.draw(ghosteyeswhite,x,y,0,scale/41, scale/41, 256, 256)
		love.graphics.draw(spinnyeyes,x,y+scale, 0, scale/41, scale/41, 145, 35)
	end
	love.graphics.setColor(r,g,b,a)
end

function editor_keypressed(key)
	if helpshown then
		helpshown=false
		return
	end
	if key == "escape" then
		menu_load(true)
	elseif key == "return" then
		custom_load(level,true)
	else
		for i,v in ipairs(shorcuts) do
			if v:sub(1,1)==key then
				if v=="erase" then
					level=editor_newlevel()
				elseif v=="save" then
					saveload_load(level,"save")
				elseif v=="load" then
					saveload_load(level,"load")
				elseif v=="help" then
					helpshown=true
				elseif v=="flags" then
					flags_load(level)
				elseif v=="axis" then
					symmetry=symmetry%#symmetrymodes+1
				elseif v=="zoom" then
					scroll[1]=(scroll[1]-screenwidth/2)/zoom
					scroll[2]=(scroll[2]-screenheight/2)/zoom
					zoom=math.min(4,zoom+.25)
					scroll[1]=(scroll[1]*zoom+screenwidth/2)
					scroll[2]=(scroll[2]*zoom+screenheight/2)
					saveoptions()
				elseif v=="unzoom" then
					scroll[1]=(scroll[1]-screenwidth/2)/zoom
					scroll[2]=(scroll[2]-screenheight/2)/zoom
					zoom=math.max(.5,zoom-.25)
					scroll[1]=(scroll[1]*zoom+screenwidth/2)
					scroll[2]=(scroll[2]*zoom+screenheight/2)
					saveoptions()
				end
			end
		end
	end
end
function editor_mousereleased(x,y,mouse)
	if mouse=="l" then
		draggingghost=false
	end
end
function editor_mousepressed(x,y,mouse)
	if helpshown then
		return
	end
	x,y=unpack(mousepos)
	if mouse=="l" then
		if tools[tool]=="walls" then
			if makingwall==false then
				makingwall={x,y}
			else
				if x~=makingwall[1] and y~=makingwall[2]then
					local x1,y1,x2,y2 = math.min(x,makingwall[1]),math.min(y,makingwall[2]),math.abs(x-makingwall[1]),math.abs(y-makingwall[2])
					table.insert(level.walls,{x1,y1,x2,y2,false})
					if symmetry%2==0 then--x
						table.insert(level.walls,{-x1-x2,y1,x2,y2,false})
					end
					if symmetry>2 then--y
						table.insert(level.walls,{x1,-y1-y2,x2,y2,false})
					end
					if symmetry==4 then--x/y
						table.insert(level.walls,{-x1-x2,-y1-y2,x2,y2,false})
					end
				end
				makingwall=false
			end
		elseif tools[tool]=="player spawn" then
			level.player={x,y}
		elseif tools[tool]=="ghosts" then
			draggingghost=false
			for i,v in ipairs(level.ghosts) do
				if ((x-v[1])^2+(y-v[2])^2)^.5 < 15 then
					draggingghost=i
				end
			end
		-- 	level.ghosts={x,y}
		end
	elseif mouse=="wu" then
		tool=(tool-2)%#tools+1
		makingwall=false
		currentdesc=toolsdesc[tools[tool]]
	elseif mouse=="wd" then
		tool=(tool)%#tools+1
		currentdesc=toolsdesc[tools[tool]]
		makingwall=false
	elseif mouse=="r" then
		if tools[tool]=="walls" then
			makingwall=false
			local todelete = 0
			for i,v in ipairs(level.walls) do
				if aabb(v,{x-1,y-1,2,2}) then
					todelete=i
				end
			end
			if todelete~=0 then
				-- table.remove(level.walls,todelete)
				editwall_load(level,todelete)
			end
		elseif tools[tool]=="ghosts" then
			local ghost = nil
			for i,v in ipairs(level.ghosts) do
				if ((x-v[1])^2+(y-v[2])^2)^.5 < 15 then
					ghost=i
				end
			end
			if ghost==nil then
				table.insert(level.ghosts,{x,y})
			else
				table.remove(level.ghosts,ghost)
			end
		end
	end
end