function levelselection_load()
	prevgamestate = gamestate
	gamestatemovetimer=1
	gamestate = "levelselection"
	listlevels=love.filesystem.enumerate('maps/')
	listlevelsminimaps={}
	listlevelshighs={}
	-- for i,v in ipairs(listlevels) do
	-- 	table.insert(listlevelsminimaps,loadcustomlevel('maps/'..v))
	-- 	table.insert(listlevelshighs,loadcustomhighscores(v))
	-- end
	releasemouse()
	margin=28*scale
	nbxitems=3
	nbyitems=2
	widthitem=screenwidth/nbxitems
	heightitem=(screenheight-margin)/nbyitems
	scaleitem=math.min(widthitem/boardwidth,heightitem/boardheight)/scale
	highscoresshown=false
	highscoresanim=0
	keyboardselection=1
	scroll=0
	zoomingon=false
	zoomstate=0
end
function levelselection_update(dt)
	gamestatemovetimer=math.max(gamestatemovetimer-dt*4,0)
	if highscoresshown then
		highscoresanim=math.min(highscoresanim+dt*8,1)
	else
		highscoresanim=math.max(highscoresanim-dt*8,0)
	end
	if zoomingon~=false then
		zoomstate=math.min(zoomstate+dt*3,1)
		if zoomstate==1 then
			custom_load(listlevelsminimaps[zoomingon],false)
		end
	end
	local wantedscroll = math.floor((keyboardselection-1)/nbxitems)*heightitem-(screenheight-margin)/2+heightitem/2
	wantedscroll=math.max(wantedscroll,0)
	wantedscroll=math.min(wantedscroll,math.floor((#listlevels-1)/nbxitems+1)*heightitem-(screenheight-margin))
	scroll=scroll*.9+wantedscroll*.1
	levelselection_loadthing()
end
function levelselection_loadthing()
	if #listlevelsminimaps<#listlevels then
		table.insert(listlevelsminimaps,loadcustomlevel('maps/'..listlevels[#listlevelsminimaps+1]))
	elseif #listlevelshighs<#listlevels then
		table.insert(listlevelshighs,loadcustomhighscores(listlevels[#listlevelshighs+1]))
	end
end

function levelselection_draw()
	if gamestatemovetimer~=0 and prevgamestate~="levelselection" then
		love.graphics.push()
		love.graphics.translate(0,windowheight*(1-gamestatemovetimer))
		love.graphics.setColor(255,255,255)
		_G[prevgamestate.."_draw"]()
		love.graphics.pop()
	end
	love.graphics.push()
		love.graphics.translate(gamestate=="levelselection" and (windowwidth*(-gamestatemovetimer)) or 0,0)
		love.graphics.push()
			love.graphics.translate(0,math.floor(.5-scroll))
			
			for i,v in ipairs(listlevels) do
				local x = (i-1)%nbxitems*widthitem
				local y = math.floor((i-1)/nbxitems)*heightitem
				if aabb({x,y-scroll,widthitem,heightitem},{0,0,screenwidth,screenheight}) then
					love.graphics.push()
						love.graphics.setStencil(function() love.graphics.rectangle('fill',x,y+margin,widthitem,heightitem) end)
						love.graphics.translate(x,y+margin)
						-- local timedraw= love.timer.getMicroTime()
						if listlevelsminimaps[i] then
							love.graphics.setColor(listlevelsminimaps[i].flags["background color"])
							love.graphics.rectangle("fill",0,0,widthitem,heightitem)
							love.graphics.setColor(255,255,255)
							love.graphics.push()
								love.graphics.translate(widthitem/2,heightitem/2)
								love.graphics.scale(scaleitem)
								-- love.graphics.translate(-boardwidth*scale/2,-boardheight*scale/2)
								drawcustomlevel(listlevelsminimaps[i],{-widthitem/2/scaleitem,-heightitem/2/scaleitem,widthitem/scaleitem,heightitem/scaleitem})
							love.graphics.pop()
						else
							love.graphics.print("loading...",scale*2,scale*10,0,scale)
						end
						love.graphics.setStencil()
						love.graphics.setColor(54,54,255)
						if i==keyboardselection then
							love.graphics.setColor(255,255,255)
						end
						love.graphics.rectangle("line",love.graphics.getLineWidth()*2,love.graphics.getLineWidth()*2,widthitem-love.graphics.getLineWidth()*4,heightitem-love.graphics.getLineWidth()*4)
						love.graphics.setColor(255,255,255)
						love.graphics.print(v,scale*2,scale*2,0,scale)
						-- love.graphics.print(v.."\n"..math.floor((love.timer.getMicroTime()-timedraw)*10000)/10000,scale*2,scale*2,0,scale)
					love.graphics.pop()
				end

			end
		love.graphics.pop()
		love.graphics.setColor(0,0,0)
		love.graphics.drawq(gradient,gradientquad,0,0,0,screenwidth,margin)
		if listlevelshighs[keyboardselection] then
			love.graphics.push()
				love.graphics.translate(0,margin)
				love.graphics.scale(1,highscoresanim)
				love.graphics.translate(0,-margin)
				for i,v in ipairs(listlevelshighs[keyboardselection]) do
					love.graphics.push()
						love.graphics.translate((i-1)*50*scale,0)
						love.graphics.setColor(255,27,27)
							love.graphics.print(i,25*scale,0,0,scale,scale,pacmanfont:getWidth(i)*scale/2)
						love.graphics.setColor(255,255,27)
							love.graphics.print(v[1],3*scale,7*scale,0,scale,scale)
						love.graphics.setColor(127,127,127)
							love.graphics.print(v[2],3*scale,14*scale,0,scale,scale)
						love.graphics.setColor(255,255,255)
							love.graphics.print("/",(pacmanfont:getWidth(v[2])+3)*scale,14*scale,0,scale,scale)
						love.graphics.setColor(255,255,27)
							love.graphics.print(v[3],3*scale,21*scale,0,scale,scale)
					love.graphics.pop()
				end
			love.graphics.pop()
		end
		love.graphics.push()
			love.graphics.scale(1,1-highscoresanim)
			love.graphics.setColor(255,255,255)
			love.graphics.setFont(bigfont)
			love.graphics.print("custom",screenwidth-("custom"):len()*6*2*scale,0,0,2*scale)
			love.graphics.print("levels",screenwidth-("levels"):len()*6*2*scale,7*2*scale,0,2*scale)
			love.graphics.setFont(pacmanfont)
			love.graphics.print("h: show highscores m: open\nmap folder esc: main menu",2*scale,2*scale,0,scale)
		love.graphics.pop()
		if zoomingon~=false then
			love.graphics.push()
				local x = (zoomingon-1)%nbxitems*widthitem
				local y = math.floor((zoomingon-1)/nbxitems)*heightitem-scroll+margin
				local w = lerp(widthitem,screenwidth,zoomstate)
				local h = lerp(heightitem,screenheight,zoomstate)
				love.graphics.setColor(listlevelsminimaps[zoomingon].flags["background color"])
				love.graphics.rectangle('fill',lerp(x,0,zoomstate),lerp(y,0,zoomstate),w,h)
				love.graphics.setColor(255,255,255)
				love.graphics.push()
					love.graphics.setStencil(function ()
						love.graphics.rectangle('fill',lerp(x,0,zoomstate),lerp(y,0,zoomstate),w,h)
					end)
					love.graphics.translate(
						lerp(x+widthitem/2,
							((listlevelsminimaps[zoomingon].flags["force 1st person"] or pacfocus)and -listlevelsminimaps[zoomingon].player[1]*zoom*scale or 0)+screenwidth/2
							,zoomstate),
						lerp(y+heightitem/2,
							((listlevelsminimaps[zoomingon].flags["force 1st person"] or pacfocus)and -listlevelsminimaps[zoomingon].player[2]*zoom*scale or 0)+screenheight/2
							,zoomstate))
					love.graphics.scale(lerp(scaleitem,zoom,zoomstate))
					-- love.graphics.translate(-boardwidth*scale/2,-boardheight*scale/2)
					drawcustomlevel(listlevelsminimaps[zoomingon])
					love.graphics.setStencil()
				love.graphics.pop()
			love.graphics.pop()
		end
	love.graphics.pop()
end
function levelselection_keypressed(key)
	if zoomingon~=false then
	elseif key == "escape" then
		menu_load(true)
	elseif key == "right" then
		keyboardselection=math.min(#listlevels,keyboardselection+1)
	elseif key == "left" then
		keyboardselection=math.max(1,keyboardselection-1)
	elseif key == "down" then
		keyboardselection=math.min(#listlevels,keyboardselection+nbxitems)
	elseif key == "up" then
		keyboardselection=math.max(1,keyboardselection-nbxitems)
	elseif key == "return" and listlevelsminimaps[keyboardselection] then
		-- custom_load(listlevelsminimaps[keyboardselection],false)
		zoomingon=keyboardselection
	elseif key == "h" then
		highscoresshown=not highscoresshown
	elseif key == "m" then
		openSaveFolder("maps")
	end
end
function levelselection_mousepressed(x,y,mouse)
	if zoomingon~=false then
	elseif mouse=="l" then
		for i,v in ipairs(listlevels) do
			local X = (i-1)%nbxitems*widthitem
			local Y = math.floor((i-1)/nbxitems)*heightitem+margin
			if aabb({X,Y,widthitem,heightitem},{x,y+scroll,0,0}) and listlevelsminimaps[i] then
				if i==keyboardselection then
					zoomingon=keyboardselection
				else
					keyboardselection=i
				end
			end
		end
	end
end