--[[
		DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE 
					Version 2, December 2004 

 Copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 

 Everyone is permitted to copy and distribute verbatim or modified 
 copies of this license document, and changing it is allowed as long 
 as the name is changed. 

			DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE 
   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 

  0. You just DO WHAT THE FUCK YOU WANT TO.
 ]]

function love.load()
	for i,v in ipairs({"functions","libs.json","normal","custom","editor","flags","menu","pause","saveload","highscoreentry","options","intro","levelselection","editwall","gamefunctions","customhighscore"}) do
		require(v)
	end
	
	------------
	--SETTINGS--
	------------
	versionofthis="v1.0"
	soundenabled = true
	fullscreen = false
	joystickdeadzone = 0.5
	love.graphics.setDefaultImageFilter("nearest","nearest")
	numhighscores = 9
	
	gravitymul = 260
	scale = 2
	zoom = 1
	
	controlmethods = {"mouse", "keyboard", "mouse direction", "joystick", "wheel steering", "wheel direct"}
	controldescriptions = {	mouse="move the mouse left\nand right",
							keyboard="use arrow keys to\nrotate, S to speed\nup",
							['mouse direction']="point with your\nmouse towards a\ndirection",
							joystick="point with your\njoystick",
							['wheel steering']="drive like a car",
							['wheel direct']="1:1 wheel to\ngame translation"}
	controlmethod = "mouse"

	
	pacfocus = false
	compactview = false
	nbghosts=3
	superpower = "normal" --clone, walls, normal
	powerupduration = 6
	superpelletblinkrate = 0.5
	wakkatimer = 0
	highscore = 0
	deathtime = 1.5
	deathdelay = 1
	mouse2rate = 0.05
	mouse2speed = 20
	volume = 10
	
	pacmouthlimit = 0.25
	mouthduration = 0.22
	
	whitelist = "abcdefghijklmnopqrstuvwxyz 0123456789"
	
	scale = 2
	flagslist={
		{name="lifes",type="number",min=1,default=3},

		{name="force 1st person",type="boolean",default=false},
		{name="force tiny gui",type="boolean",default=false},

		{name="walls color",type="color",default={27,27,255}},
		{name="walls fill color",type="color",default={0,0,0}},
		{name="background color",type="color",default={0,0,0}},

		{name="pellets color",type="color",default={255,255,0}},
		{name="super pellets color",type="color",default={255,255,0}},
		{name="gravity",type="number",default=gravitymul},

		{name="particles on powerup",type="boolean",default=false},
		{name="particles color",type="color",default={127,127,255}},

		{name="pacman bounce",type='number',default=0,step=.1,min=0},
		{name="super pacman bounce",type='number',default=0,step=.1,min=0},
		{name="ghost bounce",type='number',default=0,step=.1,min=0},

		{name="powerup duration",type='number',default=powerupduration,step=.1,min=.5}
		
	}
	
	----END----
	love.filesystem.mkdir('maps')
	love.filesystem.mkdir('screenshots')
	love.filesystem.mkdir('highscores')
	loadhighscoresA()
	loadoptions()
	
	icon = love.graphics.newImage("graphics/icon.png")
	boardwidth = 220
	boardheight = 216

	changescale(scale)
	
	
	--GRAPHICS--
	particleball= love.image.newImageData(16,16)
	particleball:mapPixel(function (x,y,r,g,b,a)
		return 255,255,255,math.max(0,255-math.sqrt((x-8)^2+(y-8)^2)/8*255)
	end)
	particleball=love.graphics.newImage(particleball)
	particleball:setFilter("linear","linear")
	gradient= love.image.newImageData(1,2)
	gradient:setPixel(0,0,255,255,255,255)
	gradient:setPixel(0,1,255,255,255,0)
	gradient=love.graphics.newImage(gradient)
	gradient:setFilter("linear","linear")
	gradientquad=love.graphics.newQuad(0,.5,1,1,1,2)

	mainfield = love.graphics.newImage("graphics/field.png") 
	mainfieldoverlay = love.graphics.newImage("graphics/fieldoverlay.png") 
	superpellet = love.graphics.newImage("graphics/superpellet.png") 
	toolsimg = love.graphics.newImage("graphics/tools.png")

	ghost = love.graphics.newImage("graphics/ghost.png")
	ghosteyeswhite = love.graphics.newImage("graphics/ghosteyes.png")
	ghostcolors={{255,171,255},{255,159,112},{132,193,255}}

	ghostscared1 = love.graphics.newImage("graphics/ghostscared1.png")
	ghostscared2 = love.graphics.newImage("graphics/ghostscared2.png")
	ghosteyes = love.graphics.newImage("graphics/eyes.png")
	spinnyeyes = love.graphics.newImage("graphics/spinnyeyes.png")
	title = love.graphics.newImage("graphics/title.png") 
	gamescoreimg = love.graphics.newImage("graphics/gamescore.png") 
	highscoreimg = love.graphics.newImage("graphics/highscore.png") 
	gameoverimg = love.graphics.newImage("graphics/gameover.png") 
	clockimg = love.graphics.newImage("graphics/clock.png") 
	optionsimg = love.graphics.newImage("graphics/options.png") 
	logo = love.graphics.newImage("graphics/logo.png")
	logoblood = love.graphics.newImage("graphics/logoblood.png")
	
	
	pacmanfont = love.graphics.newImageFont(love.graphics.newImage("graphics/font.png"), "0123456789abcdefghijklmnopqrstuvwxyz.:/,'C-_> <!?+[]RAVS")
	pacmanfont:setLineHeight(1.5)
	bigfont = love.graphics.newImageFont(love.graphics.newImage("graphics/bigfont.png"), "abcdefghijklmnopqrstuvwxyz 0123456789")
	bigfont:setLineHeight(1.5)
	love.graphics.setFont(pacmanfont)
	
	--SOUNDS--
	wakka1 = love.audio.newSource("sounds/pacman_waka_wa.ogg", "static")
	wakka2 = love.audio.newSource("sounds/pacman_waka_ka.ogg", "static")
	eatghost = love.audio.newSource("sounds/eat_ghost.ogg", "static"); eatghost:setVolume(0.5)
	ghostsiren = love.audio.newSource("sounds/ghosts_siren.ogg", "static"); ghostsiren:setVolume(0); ghostsiren:setLooping(true)
	ghostrunaway = love.audio.newSource("sounds/ghosts_runaway.ogg", "static"); ghostrunaway:setVolume(0); ghostrunaway:setLooping(true)
	beginning = love.audio.newSource("sounds/pacman_beginning.ogg", "static")
	gamewin = love.audio.newSource("sounds/win.ogg", "static")
	death = love.audio.newSource("sounds/pacman_death.ogg", "static")
	stabsound = love.audio.newSource("sounds/stab.ogg", "static")
	intro_load()
end

function love.update(dt)
	if skipupdate then
		skipupdate = false
		return
	end
	dt = math.min(dt, 1/30)
	if _G[gamestate .. "_update"] then
		_G[gamestate .. "_update"](dt)
	end
end

function love.draw()
	-- love.graphics.translate(windowwidth/2,windowheight/2)
	-- love.graphics.shear(.2,.1)
	-- love.graphics.rotate((-.2*love.timer.getMicroTime())%(math.pi*2))
	-- love.graphics.scale(.9)
	-- love.graphics.translate(-windowwidth/2,-windowheight/2)
	if _G[gamestate .. "_draw"] then
		_G[gamestate .. "_draw"]()
	end
end

function love.keypressed(key, unicode)
	if key=="f2" then
		local screenshot = love.graphics.newScreenshot()

		love.graphics.setColor(0,0,0)
		love.graphics.print("screenshoting...",scale,2*scale,0,scale)
		love.graphics.setColor(255,255,255)
		love.graphics.print("screenshoting...",scale,scale,0,scale)
		love.graphics.present()

		screenshot:mapPixel(function (x,y,r,g,b,a) return r,g,b,255 end)

		love.graphics.setColor(0,0,0)
		love.graphics.print("saving...",scale,11*scale,0,scale)
		love.graphics.setColor(255,255,255)
		love.graphics.print("saving...",scale,10*scale,0,scale)
		love.graphics.present()

		screenshot:encode(os.date("screenshots/screenshot-%Y-%m-%d-%H_%M_%S.png"))
	elseif _G[gamestate .. "_keypressed"] then
		_G[gamestate .. "_keypressed"](key, unicode)
	end
end

function love.mousepressed(x, y, button)
	if _G[gamestate .. "_mousepressed"] then
		_G[gamestate .. "_mousepressed"](x, y, button)
	end
end
function love.mousereleased(x, y, button)
	if _G[gamestate .. "_mousereleased"] then
		_G[gamestate .. "_mousereleased"](x, y, button)
	end
end

function love.joystickpressed(joystick, button)
	if _G[gamestate .. "_joystickpressed"] then
		_G[gamestate .. "_joystickpressed"](joystick, button)
	end
end


function changescale(s)
	local grabbed = love.mouse.isGrabbed()
	scale = s
	
	windowwidth = 320*scale
	windowheight = 250*scale

	local maxreso = love.graphics.getModes()
	table.sort(maxreso,function(a,b)return a.width*a.height>b.width*b.height end)
	--Why the fuck I cant draw anything in fullscreen when I do this
	-- local nextwscreen = fullscreen and 0 or windowwidth
	-- local nexthscreen = fullscreen and 0 or windowheight
	local nextwscreen = fullscreen and maxreso[1].width or windowwidth
	local nexthscreen = fullscreen and maxreso[1].height or windowheight
	windowwidth=nextwscreen
	windowheight=nexthscreen

	screenwidth = windowwidth
	screenheight = windowheight
	leveloffset={windowwidth/2-boardwidth*scale/2,windowheight/2-boardheight*scale/2}
	
	fsaa = 2
	vsync = true
	love.graphics.setLineWidth(5/3*scale)
	
	if gamestate == "options" then
		options_createdemoworld()
	end
	local dumb,dumb,isfullscreen,dumb,dumb = love.graphics.getMode()
	if love.graphics.getWidth() ~= windowwidth or love.graphics.getHeight() ~= windowheight or isfullscreen~=fullscreen then
		love.graphics.setMode(nextwscreen, nexthscreen, fullscreen, vsync, fsaa)
	end
	
	love.graphics.setIcon(icon)
	
	love.mouse.setGrab(grabbed)
end
function loadhighscoresA()
	loadhighscores("highscoreA","highscoreA")
	savehighscoresA()
end
function loadhighscores(path,variable)
	if love.filesystem.exists(path) then
		local s = love.filesystem.read(path):split("#")
		if #s < 2 then
			s[3] = s[1]
		else
			controlmethod = s[1]
			scale = tonumber(s[2])
		end
		local t = s[3]
		_G[variable] = t:split(";")
		for i = 1, #_G[variable] do
			_G[variable][i] = _G[variable][i]:split(":")
			_G[variable][i][1] = tonumber(_G[variable][i][1])
			_G[variable][i][2] = tonumber(_G[variable][i][2])
		end
	else
		_G[variable] = {}
		for i = 1, numhighscores do
			_G[variable][i] = {0, 0, "------"}
		end
	end
	
end

function savehighscoresA()
	savehighscores("highscoreA",highscoreA)
end
function savehighscores(path,highscore)
	local s = controlmethod .. "#"
	local s = s .. scale .. "#"
	for i = 1, numhighscores do
		if (highscore[i][1] and highscore[i][2] and highscore[i][3]) then
			s = s .. highscore[i][1] .. ":" .. highscore[i][2] .. ":" .. highscore[i][3]
		else
			s = s .. "------" .. ":0:0"
		end
		if i ~= numhighscores then
			s = s .. ";"
		end
	end
	
	love.filesystem.write(path, s)
end
function saveoptions()
	love.filesystem.write("notoptions",json.encode({
		pacfocus=pacfocus,
		fullscreen=fullscreen,
		zoom=zoom,
		compactview=compactview}))
end
function loadoptions()
	if not love.filesystem.exists("notoptions") then saveoptions() end
	local loadedoptions = json.decode(love.filesystem.read("notoptions"))

	pacfocus=loadedoptions.pacfocus
	zoom=loadedoptions.zoom
	fullscreen=loadedoptions.fullscreen
	compactview=loadedoptions.compactview
end
function loadcustomhighscores(name)
	local path = "highscores/"..name..".txt"
	if not love.filesystem.exists(path) then
		local Hscores = {}
		for i=1,numhighscores do
			table.insert(Hscores,{"------",0,0})
		end
		return Hscores
	end
	return json.decode(love.filesystem.read(path))
end
function savecustomhighscores(name,Hscores)
	local path = "highscores/"..name..".txt"
	return love.filesystem.write(path,json.encode(Hscores))
end