function menu_load(skip)
	prevgamestate = gamestate
	gamestatemovetimer=1
	gamestate = "menu"
	starttime=love.timer.getMicroTime()+4*50*scale/64
	introdelay = 1.5
	introtime = introdelay
	menustarted = false
	listmenu={"classic","custom level","editor","options","quit"}
	menuselection = menuselection or 1
	menuselectiony=menuselection
	
	normal_stopgamesounds()
	oldmousex,oldmousey=0,0
	if skip then
		menustarted = true
		introtime=0
	end
	
	releasemouse()
end

function menu_update(dt)
	gamestatemovetimer=math.max(gamestatemovetimer-dt*4,0)
	if menustarted == false then
		introtime=math.max(0,introtime-dt*4)
	else
		introtime=math.max(0,introtime-dt*8)
	end
	if introtime <= 0 then
		menustarted = true
	end
	if menuselectiony>menuselection then
		menuselectiony=math.max(menuselection,menuselectiony-dt*32)
	else
		menuselectiony=math.min(menuselection,menuselectiony+dt*32)
	end
	if oldmousex~=love.mouse.getX() or oldmousey~=love.mouse.getY() then
		for i,v in ipairs(listmenu) do
			if aabb({love.mouse.getX(),love.mouse.getY(),0,0},
				{screenwidth/2-48*scale,
				screenheight/2+(12*(i-1))*scale,
				48*scale*2,
				12*scale}) then
				menuselection=i
			end
		end
	end
	oldmousex,oldmousey=love.mouse.getPosition()
end

function menu_draw()
	if (gamestatemovetimer~=0 or prevgamestate=="pause") and prevgamestate~="menu" then
		love.graphics.setColor(255,255,255)
		love.graphics.push()
		if prevgamestate=="pause" then
			love.graphics.translate(0,windowheight*(gamestatemovetimer-1)/3)
		else
			love.graphics.translate(0,windowheight*(gamestatemovetimer-1))
		end
		if prevgamestate=="pause" then
			_G[pausedgamestate.."_draw"]()
		else
			_G[prevgamestate.."_draw"]()
		end
		love.graphics.pop()
	end
	love.graphics.push()
	love.graphics.translate(0,gamestate=="menu" and (windowheight*(gamestatemovetimer)) or 0)
	love.graphics.setColor(0,0,0,127)
	love.graphics.rectangle('fill',0,0,screenwidth,screenheight)
	love.graphics.setColor(255,255,255)
	local Scale = 1-introtime/introdelay
	love.graphics.push()
	love.graphics.translate(screenwidth/2,screenheight/2)
	love.graphics.scale(Scale)
	love.graphics.translate(-screenwidth/2,-screenheight/2)

	love.graphics.draw(title, screenwidth/2-150*scale, screenheight/2-150*scale, 0, scale)
	love.graphics.setColor(255,140,12)
	love.graphics.print(versionofthis,screenwidth/2+85*scale,screenheight/2-20*scale,0,scale)
	love.graphics.setColor(252, 116, 96)
	love.graphics.print('>',screenwidth/2-64*scale,screenheight/2+(12*(menuselectiony-1))*scale,0,scale)
	for i,v in ipairs(listmenu) do
		love.graphics.setColor(102, 102, 102)
		if i==menuselection then
			love.graphics.setColor(255, 255, 255)
		end
		love.graphics.print(v, screenwidth/2-48*scale, screenheight/2+(12*(i-1))*scale, 0, scale)
	end
	love.graphics.setColor(255, 255, 255)
	love.graphics.setFont(bigfont)
	love.graphics.print("mod by felix dumenil",screenwidth/2-118*scale,screenheight/2-20*scale,0,scale)
	love.graphics.setFont(pacmanfont)

	love.graphics.pop()
	for columns=0,fullscreen and 3 or 1 do
		love.graphics.push()
		love.graphics.translate(
			(((starttime-love.timer.getMicroTime())*64)%(50*#highscoreA*scale))
			-(50*#highscoreA*scale)*(columns-(fullscreen and 1.5 or 0)) ,0)
		for i,v in ipairs(highscoreA) do
			local gt = v[2]
			
			if math.mod(gt, 1) == 0 then
				gt = gt .. ".0"
			end
			love.graphics.push()
			love.graphics.translate((i-1)*50*scale,16*scale)
			love.graphics.setColor(255, 27, 27)
			if i==1 then
				love.graphics.print(i,16*scale,-9*scale,0,scale)
				love.graphics.print(i,16*scale,-11*scale,0,scale)
				love.graphics.print(i,17*scale,-10*scale,0,scale)
				love.graphics.print(i,15*scale,-10*scale,0,scale)
				love.graphics.setColor(255, 255, 27)
			end
			love.graphics.print(i,16*scale,-10*scale,0,scale)
			love.graphics.setColor(255, 255, 255)
			love.graphics.print(v[3],0,0, 0, scale)

			love.graphics.setColor(255, 255, 0)
			love.graphics.print(v[1],8*scale, 10*scale, 0, scale)
			love.graphics.rectangle("fill", 2*scale, 12*scale, 4*scale, 4*scale)

			love.graphics.setColor(127, 127, 127)
			love.graphics.print(gt,8*scale, 20*scale, 0, scale)

			love.graphics.setColor(255, 255, 255)
			love.graphics.draw(clockimg,0, 20*scale, 0, scale, scale)

			love.graphics.pop()
		end
		love.graphics.pop()
	end
	love.graphics.setColor(love.graphics.getBackgroundColor())
	love.graphics.rectangle("fill",0,0,screenwidth/2-300*scale,screenheight)
	love.graphics.drawq(gradient,gradientquad,screenwidth/2-300*scale,0,math.pi/2,screenheight,-50*scale)

	love.graphics.rectangle("fill",screenwidth,0,-(screenwidth/2-300*scale),screenheight)
	love.graphics.drawq(gradient,gradientquad,screenwidth/2+300*scale,0,math.pi/2,screenheight,50*scale)
	love.graphics.setColor(255,255,255)
	love.graphics.pop()
end

function menu_keypressed(key)
	if key == "escape" then
		love.event.quit()
	end
	
	if menustarted == false then
		menustarted = true
	elseif key == "return" then
		menu_return()
	elseif key == "up" then
		menuselection=(menuselection-2)%#listmenu+1
	elseif key == "down" then
		menuselection=(menuselection)%#listmenu+1
	end
end
function menu_mousepressed(x,y,button)
	if button=="l"then
		menu_return()
	-- elseif button == "wu" then
	-- 	menuselection=(menuselection-2)%#listmenu+1
	-- elseif button == "wd" then
	-- 	menuselection=(menuselection)%#listmenu+1
	end
end
function menu_return()
	if listmenu[menuselection] == "classic" then
		normal_load()
	elseif listmenu[menuselection] == "custom level" then
		levelselection_load()
	elseif listmenu[menuselection] == "options" then
		options_load()
	elseif listmenu[menuselection] == "editor" then
		editor_load()
	elseif listmenu[menuselection] == "quit" then
		love.event.quit()
	end
end
function menu_joystickpressed(joystick, button)
	if menustarted == false then
		menustarted = true
	else
		normal_load()
	end
end