function options_load()
	prevgamestate = gamestate
	gamestatemovetimer=1
	gamestate = "options"
	optionsselection = 1
	for i = 1, #controlmethods do
		if controlmethods[i] == controlmethod then
			optionsselection = i
			break
		end
	end
	
	options_createdemoworld()
	
	demorotation = 0
	demotargetrotation = 0
	options_updategravity(1)
	demoupdates = 0
	
	ghostx = windowwidth+500
	
	optionsmouth = pacmouthlimit
	mouthdir = -1
	
	lockmouse()
	menuoptions={}
	for i,v in ipairs(controlmethods) do
		table.insert(menuoptions,{v,desc=controldescriptions[v],enter=function()
			controlmethod = v
			lockmouse()
		end})
	end
	table.insert(menuoptions,{""})
	table.insert(menuoptions,{"volume",desc="change volume",print=function ()
		return "volume: "..(volume > 0 and "< " or "  ")..volume..(volume < 10 and " >" or "")
	end,canR=function() return volume<10 end,canL=function() return volume>0 end,right=function ()
		if volume < 10 then
			volume = volume + 1
			love.audio.setVolume(volume/10)
			local sound = _G["wakka" .. math.mod(volume, 2)+1]
			sound:stop()
			sound:play()
		end
	end,left=function ()
		if volume > 0 then
			volume = volume - 1
			love.audio.setVolume(volume/10)
			local sound = _G["wakka" .. math.mod(volume, 2)+1]
			sound:stop()
			sound:play()
		end
	end})
	table.insert(menuoptions,{"scale",desc="change the size\nof the window",print=function ()
		return "scale: "..(scale > 1 and "< " or "  ")..scale..(scale < 4 and " >" or "")
	end,canR=function() return scale<4 end,canL=function() return scale>1 end,right=function ()
		if scale < 4 then
			changescale(scale+1)
		end
	end,left=function ()
		if scale > 1 then
			changescale(scale-1)
		end
	end})
	table.insert(menuoptions,{"tiny gui",desc="make the gui take\nless space on\nthe screen.",print=function ()
		return "tiny gui: "..(compactview and "on" or "off") end,
		enter=function () compactview=not compactview end})
	table.insert(menuoptions,{"1st person",desc="move the camera at\npacman's position.",print=function ()
		return "1st person: "..(pacfocus and "on" or "off") end,
		enter=function () pacfocus=not pacfocus end})
	table.insert(menuoptions,{"zoom",desc="zoom on the board."
		,canR=function() return zoom<4 end,canL=function() return zoom>.5 end,right=function ()
		if zoom < 4 then
			zoom=zoom+.25
		end end,left=function ()
		if zoom > .5 then
			zoom=zoom-.25
		end end,print=function ()
			return "zoom: "..(zoom > .5 and "< " or "  ")..zoom..(zoom < 4 and " >" or "")
		end})

	table.insert(menuoptions,{"fullscreen",desc="put the game in\nfullscreen, at the\nbiggest resolution.",print=function ()
		return "fullscreen: "..(fullscreen and "on" or "off") end,
		enter=function () fullscreen=not fullscreen;changescale(scale) end})
	--fullscreen
	rclickpacman={x=0,angle=0}
end

function options_createdemoworld()
	--demo world
	demoworld = love.physics.newWorld(0, 800, false)
	
	demofieldbody = love.physics.newBody(demoworld, screenwidth / 2, screenheight / 2, 0, 0)
	
	demoworldshapes = {}
	demoworldfix = {}
	demoworldshapes[1] = love.physics.newRectangleShape(-25*scale, 0*scale, 10*scale, 50*scale)
	demoworldshapes[2] = love.physics.newRectangleShape(0*scale, -25*scale, 50*scale, 10*scale)
	demoworldshapes[3] = love.physics.newRectangleShape(25*scale, 0*scale, 10*scale, 50*scale)
	demoworldshapes[4] = love.physics.newRectangleShape(0*scale, 25*scale, 50*scale, 10*scale)
	demoworldshapes[5] = love.physics.newRectangleShape(0*scale, 0*scale, 5*scale, 5*scale)
	for i,v in ipairs(demoworldshapes) do
		demoworldfix[i]=love.physics.newFixture(demofieldbody,v)
	end

	
	demopacmanbody = love.physics.newBody(demoworld, screenwidth/2-4*scale, screenheight/2-10*scale,"dynamic")
	demopacmanbody:setBullet(true)
	demopacmanbody:setMass(0.1)
	demopacmanbody:setInertia( 0.001 )
	demopacmanshape = love.physics.newCircleShape(6.5*scale)
	-- demopacmanshape:setFriction( 1000)
	demopacmanfix=love.physics.newFixture(demopacmanbody,demopacmanshape)
	demopacmanfix:setMask(3)
end

function options_update(dt)
	demoworld:update(dt)
	options_updategravity(dt)
	gamestatemovetimer=math.max(gamestatemovetimer-dt*4,0)
	
	--Controls
	if controlmethod == "joystick" then
		x = love.joystick.getAxis( 1, 0 )
		y = -love.joystick.getAxis( 1, 1 )
		if math.abs(x) + math.abs(y) > joystickdeadzone then
			demotargetrotation = math.deg(math.atan2(x, y) )
		end
	elseif controlmethod == "wheel steering" then
		x = love.joystick.getAxis( 1, 0)
		demotargetrotation = demotargetrotation+x*dt*400
		if demotargetrotation < 0 then
			demotargetrotation = demotargetrotation + 360
		elseif demotargetrotation > 360 then
			demotargetrotation = demotargetrotation - 360
		end
	elseif controlmethod == "wheel direct" then
		x = love.joystick.getAxis( 1, 0)
		demotargetrotation = x*180
		if demotargetrotation < 0 then
			demotargetrotation = demotargetrotation + 360
		end
	elseif controlmethod == "keyboard" then
		local multiplier = 100
		if love.keyboard.isDown( "rshift" ) or love.keyboard.isDown( "lshift" ) then
			multiplier = 300
		end
		if love.keyboard.isDown( "left" ) then
			demotargetrotation = demotargetrotation - multiplier*dt
		end
		if love.keyboard.isDown( "right" ) then
			demotargetrotation = demotargetrotation + multiplier*dt
		end
	elseif controlmethod == "mouse direction" then
		x, y = love.mouse.getPosition( )
		x = x - (windowwidth/2+windowwidth/4.5)
		y = (windowheight/2-windowheight/5) - y
		demotargetrotation = math.deg(math.atan2(x, y))
	elseif controlmethod == "mouse" and not love.mouse.isDown("r")then
		x, y = love.mouse.getPosition()
		
		if oldx then
			diff = x-oldx
			demotargetrotation = demotargetrotation+diff*dt*mouse2speed
		end
		
		oldx, oldy = x, y
		
		demoupdates = demoupdates + dt
		if demoupdates > mouse2rate then
			demoupdates = 0
			oldx = windowwidth/2
			love.mouse.setPosition(windowwidth/2, windowheight/2)
		end
	end
	
	optionsmouth = optionsmouth + dt*mouthdir*3
	
	if optionsmouth < 0 then
		optionsmouth = 0
		mouthdir = 1
	elseif optionsmouth > pacmouthlimit then
		optionsmouth = pacmouthlimit
		mouthdir = -1
	end
	
	ghostx = ghostx - dt*150*scale
	if ghostx < -1000 then
		ghostx = windowwidth + 500
	end
	if love.mouse.isDown("r") then
		x, y = love.mouse.getPosition()
		
		if oldx then
			diff = x-oldx
			rclickpacman.x = rclickpacman.x+diff*dt*.2
			if diff>0 then
				rclickpacman.angle=math.pi
			elseif diff<0 then
				rclickpacman.angle=0
			end
		end
		
		oldx, oldy = x, y
		
		demoupdates = demoupdates + dt
		if demoupdates > mouse2rate then
			demoupdates = 0
			oldx = windowwidth/2
			love.mouse.setPosition(windowwidth/2, windowheight/2)
		end
		if rclickpacman.x<-1 then
			rclickpacman.x=0
			if menuoptions[optionsselection].left then
				menuoptions[optionsselection]:left()
			end
		end
		if rclickpacman.x>1 then
			rclickpacman.x=0
			if menuoptions[optionsselection].right then
				menuoptions[optionsselection]:right()
			end
		end
	end
end

function options_draw()
	if gamestatemovetimer~=0 and prevgamestate~="options" then
		love.graphics.push()
		love.graphics.translate(0,windowheight*(1-gamestatemovetimer))
		love.graphics.setColor(255,255,255)
		_G[prevgamestate.."_draw"]()
		love.graphics.pop()
	end
	love.graphics.push()
	love.graphics.translate(gamestate=="options" and (windowwidth*(gamestatemovetimer)) or 0,0)
	----
	--DRAW THE WORLD
	----

	--Rotate da worl
	love.graphics.push()
	love.graphics.translate(windowwidth/2, windowheight/2)
	love.graphics.translate(windowwidth/4.5, -windowheight/5)
	love.graphics.rotate(math.rad(demorotation))
	if not pacfocus then
		love.graphics.scale(zoom)
	end
	love.graphics.translate(-windowwidth/2, -windowheight/2)
	if pacfocus then
		love.graphics.scale(zoom)
		love.graphics.translate(-demopacmanbody:getX()+screenwidth/2/zoom, -demopacmanbody:getY()+screenheight/2/zoom)
	end
	--Demo Pacman
	love.graphics.setColor(255, 255, 50)
	love.graphics.arc("fill",demopacmanbody:getX(),demopacmanbody:getY(),6.5*scale,math.pi*.25+demopacmanbody:getAngle(),math.pi*1.75+demopacmanbody:getAngle())
	
	love.graphics.setColor(27, 27, 255)
	drawstyledrect(windowwidth/2-21*scale, windowheight/2-21*scale, 42*scale, 42*scale)
	drawstyledrect(windowwidth/2-24*scale, windowheight/2-24*scale, 48*scale, 48*scale)
	love.graphics.rectangle("fill",windowwidth/2-2*scale, windowheight/2-2*scale, 4*scale, 4*scale)
	love.graphics.pop()

	----
	--LOGO
	----

	love.graphics.setColor(255, 255, 255)
	love.graphics.draw(optionsimg, windowwidth/2-32*scale, 14*scale, 0, scale, scale)
	
	----
	--LEFT RECTANGLE
	----
	love.graphics.setColor(0, 0, 0,192)
	love.graphics.rectangle("fill", 5*scale, 43*scale, 140*scale, 180*scale)
	love.graphics.setColor(255, 255, 255)
	drawstyledrect(5*scale, 43*scale, 140*scale, 180*scale)

	love.graphics.setColor(164, 0, 0)
	love.graphics.setFont(bigfont)
	love.graphics.print("control scheme", 8*scale, 33*scale, 0, scale)
	love.graphics.setFont(pacmanfont)

	love.graphics.setColor(255, 255, 255)
	for i,v in ipairs(menuoptions) do
		if optionsselection == i then
			love.graphics.setColor(255, 255, 255)
		else
			love.graphics.setColor(127, 127, 127)
		end
		love.graphics.print(v.print and v:print() or v[1], 20*scale, ((i-1)*12+50)*scale, 0, scale)
	end

	
	local bla = 1
	for i = 1, #controlmethods do
		if controlmethods[i] == controlmethod then
			bla = i
			break
		end
	end
	
	love.graphics.setColor(252, 116, 96)
	love.graphics.print(">", 8*scale, ((bla-1)*12+50)*scale, 0, scale)
	----
	--DESCRIPTION RECTANGLE
	----
	love.graphics.setColor(0,0,0,127)
	--250-145=105
	love.graphics.rectangle("fill", screenwidth-170*scale, screenheight-105*scale, 165*scale, 53*scale)
	love.graphics.setColor(255, 255, 255)
	drawstyledrect(screenwidth-170*scale, screenheight-105*scale, 165*scale, 53*scale)--150
	love.graphics.print(menuoptions[optionsselection].desc or "no description . :i", screenwidth-167*scale, screenheight-100*scale, 0, scale)

	love.graphics.setColor(164, 0, 0)
	love.graphics.setFont(bigfont)
	love.graphics.print("description", screenwidth-167*scale, screenheight-115*scale, 0, scale)
	love.graphics.setFont(pacmanfont)
	love.graphics.setColor(255, 255, 255)
	----
	--RIGHT CLICK THINGY
	----
	if love.mouse.isDown("r") and (menuoptions[optionsselection].left or menuoptions[optionsselection].right)then--rclickpacman
		love.graphics.setColor(127,13,13,255*math.abs(rclickpacman.x))
		if rclickpacman.x>0 then
			love.graphics.rectangle("fill",225*scale,207*scale,((100+13)/2-1)*scale,(13-2)*scale)
		else
			love.graphics.rectangle("fill",226*scale-50*scale-7*scale,207*scale,((100+13)/2-1)*scale,(13-2)*scale)
		end
		love.graphics.setColor(127,13,13)
		if menuoptions[optionsselection].left and (not menuoptions[optionsselection].canL or menuoptions[optionsselection].canL())then
			love.graphics.rectangle("fill",(226-50-7)*scale,207*scale,10*scale,(13-2)*scale)
		end
		if menuoptions[optionsselection].right and (not menuoptions[optionsselection].canR or menuoptions[optionsselection].canR())then
			love.graphics.rectangle("fill",(224+50+7-11)*scale,207*scale,10*scale,(13-2)*scale)
		end
		love.graphics.setColor(255, 255,50)
		love.graphics.arc("fill",
			225*scale+rclickpacman.x*50*scale,
			212.5*scale,6*scale,math.pi*2*(optionsmouth/2)-math.pi+rclickpacman.angle, rclickpacman.angle+math.pi*2 - math.pi*2*(optionsmouth/2)-math.pi)
		love.graphics.setColor(127,13,13)
		drawstyledrect(225*scale-50*scale-7*scale,206*scale,(100+13)*scale,13*scale)
		love.graphics.setColor(255, 255, 255)
	end
	----
	--BOTTOM BAR
	----
	
	--Silly ghosts
	for i = 1, 3 do
		love.graphics.draw(ghostscared1, ghostx + i*25*scale, windowheight-20*scale, 0, scale/40, scale/40)
	end
	
	love.graphics.setColor(255, 255, 50)
	love.graphics.arc("fill",ghostx + 120*scale,windowheight-13*scale,6.5*scale,math.pi*2*(optionsmouth/2)-math.pi, math.pi*2 - math.pi*2*(optionsmouth/2)-math.pi)
	
	love.graphics.setColor(0, 0, 255)
	love.graphics.rectangle("line", -10, windowheight-22*scale, windowwidth+20, 18*scale)
	
	love.graphics.pop()
	love.graphics.setColor(255,255,255)
end

function options_updategravity(dt) --"rotates" the world. (It actually only changes the gravity "direction" because actually rotating the world caused centrifugalforces to be a bitch)
	--smooth targetrotation into rotation
	
	demotargetrotation = math.mod(demotargetrotation+360, 360)
	
	if demotargetrotation > demorotation + 180 then
		demorotation = demorotation + 360
	elseif demotargetrotation < demorotation - 180 then
		demorotation = demorotation - 360
	end
	
	if demotargetrotation > demorotation then
		demorotation = demorotation + (demotargetrotation-demorotation)*dt*20
	else
		demorotation = demorotation + (demotargetrotation-demorotation)*dt*20
	end
	
	demogravityX = math.sin(math.rad(demorotation))
	demogravityY = math.cos(math.rad(demorotation))	
	demoworld:setGravity( demogravityX*gravitymul*scale, demogravityY*gravitymul*scale )
end

function options_keypressed(key, uni)
	if key == "escape" then
		savehighscoresA()
		saveoptions()
		menu_load(true)
	end
	if key=="right" and menuoptions[optionsselection].right then--callbacks
		menuoptions[optionsselection]:right()
	elseif key=="left" and menuoptions[optionsselection].left then
		menuoptions[optionsselection]:left()
	elseif key=="return" and menuoptions[optionsselection].enter then
		menuoptions[optionsselection]:enter()
	end
	if key == "up" then
		optionsselection = math.max(optionsselection - 1, 1)
		while menuoptions[optionsselection][1]=="" do
			optionsselection = math.max(optionsselection - 1, 1)
		end
		rclickpacman.x=0
	elseif key == "down" then
		optionsselection = math.min(optionsselection + 1,#menuoptions)
		while menuoptions[optionsselection][1]=="" do
			optionsselection = math.min(optionsselection + 1,#menuoptions)
		end
		rclickpacman.x=0
	end
end
function options_mousepressed(x,y,button)
	if button=="r" then
		rclickpacman.x=0
	end
	if button=="l" and menuoptions[optionsselection].enter then
		menuoptions[optionsselection]:enter()
	end
	if button == "wu" then
		optionsselection = math.max(optionsselection - 1, 1)
		while menuoptions[optionsselection][1]=="" do
			optionsselection = math.max(optionsselection - 1, 1)
		end
		rclickpacman.x=0
	elseif button == "wd" then
		optionsselection = math.min(optionsselection + 1,#menuoptions)
		while menuoptions[optionsselection][1]=="" do
			optionsselection = math.min(optionsselection + 1,#menuoptions)
		end
		rclickpacman.x=0
	end
end