function saveload_load(customlevel,saveorload)
	customoriglevel=customlevel
	action=saveorload
	gamestate = "saveload"
	listlevels=love.filesystem.enumerate('maps/')
	pathactions="mylevel"..math.random(0,1000)
	if action=="load" then
		pathactions=listlevels[1] or pathactions
	end
	releasemouse()
	zonelistlevel={4*scale,30*scale,screenwidth-8*scale,screenheight-50*scale}
end
function saveload_update(dt)
end

function saveload_draw()
	love.graphics.print(action,screenwidth/2-action:len()*8*scale,4*scale,0,2*scale)
	if love.timer.getMicroTime()*2%2>1 then
	end
	love.graphics.setColor(255,255,255,
		(1-((1-math.cos(love.timer.getMicroTime()*10))*.5))*255
		)
	love.graphics.print('_',(('>'..pathactions):len()*8+8)*scale,screenheight-14*scale,0,scale)
	love.graphics.setColor(255,255,255)
	love.graphics.print('>'..pathactions,8*scale,screenheight-14*scale,0,scale)
	love.graphics.setScissor(unpack(zonelistlevel))
	love.graphics.push()
		love.graphics.translate(8*scale,34*scale)
		for i,v in ipairs(listlevels) do
			if v==pathactions then
				love.graphics.setColor(27,27,255)
				love.graphics.rectangle('fill',-4*scale,((i-1)*10-1)*scale,zonelistlevel[3],10*scale)
				love.graphics.setColor(255,255,255)
			end
			love.graphics.print(v,0,(i-1)*10*scale,0,scale)
		end
	love.graphics.pop()
	love.graphics.setScissor()

	love.graphics.setColor(27,27,255)
	drawstyledrect(2*scale,screenheight-18*scale,screenwidth-4*scale,16*scale)
	drawstyledrect(zonelistlevel[1]-1,zonelistlevel[2]-1,zonelistlevel[3]+2,zonelistlevel[4]+2)
	love.graphics.setColor(255,255,255)
end
function saveload_keypressed(key,unicode)
	if key == "escape" then
		editor_load(customoriglevel,scroll)
	elseif key == "backspace" then
		pathactions=pathactions:sub(1,pathactions:len()-1)
	elseif key == "return" then
		if action=="save" then
			savecustomlevel(customoriglevel,"maps/"..pathactions)
			editor_load(customoriglevel,scroll)
			gamestatemovetimer=0
		elseif action=="load" then
			if love.filesystem.exists("maps/"..pathactions) then
				editor_load(loadcustomlevel("maps/"..pathactions),scroll)
				gamestatemovetimer=0
			end
		end
	elseif key=="down" then
		for i,v in ipairs(listlevels) do
			if v==pathactions then
				pathactions=listlevels[i%#listlevels+1]
				return
			end
		end
	elseif key=="up" then
		for i,v in ipairs(listlevels) do
			if v==pathactions then
				pathactions=listlevels[(i-2)%#listlevels+1]
				return
			end
		end
	else
		if unicode > 31 and unicode < 127 then
			pathactions = pathactions .. string.char(unicode):lower()
		end
	end
end
function saveload_mousepressed(x,y,mouse)
	if mouse=="l" then
		for i,v in ipairs(listlevels) do
			if aabb({x,y,1,1},{8*scale,(34+(i-1)*10)*scale,screenwidth-22*scale,10*scale}) then
				pathactions=v
			end
		end
	end
end
function savecustomlevel(customlevel,path)
	local thetable = {
		player=customlevel.player,
		ghost=customlevel.ghosts,
		flags=customlevel.flags
	}
	if #customlevel.walls>0 then
		thetable.walls=customlevel.walls
	end
	for k,v in pairs(customlevel.pellets) do
		thetable.pellets = thetable.pellets or {}
		table.insert(thetable.pellets,v)
	end
	love.filesystem.write(path,json.encode(thetable))
end
function loadcustomlevel(path)
	local thetable = json.decode(love.filesystem.read(path))
	local pellets = {}
	for i,v in ipairs(thetable.pellets or {}) do
		pellets[v[1].." "..v[2]]=v
	end
	local flags = {}
	for i,v in ipairs(flagslist) do
		flags[v.name]=v.default
	end
	if thetable.flags then
		for k,v in pairs(thetable.flags) do
			flags[k]=v
		end
	end
	local ghosts = thetable.ghost or {}
	if type(ghosts[1])=="number" then
		ghosts={}
		for i=1,nbghosts do
			table.insert(ghosts,{thetable.ghost[1]+(i-(nbghosts+1)/2)*15,thetable.ghost[2]})
		end
	end
	for i,v in ipairs(thetable.walls) do
		v[5]=v[5] or false
	end
	return {walls=(thetable.walls or {}),player=thetable.player,ghosts=ghosts,pellets=pellets,flags=flags,path=path}
end